
#ifdef USE_PCRE
#include "pcre.bi"
function IsMatch(byval aPattern as string, byval aBuffer as string) as integer
  dim regex as pcre ptr
  dim errcode as zstring ptr 
  dim erroffset as integer
  dim ovector as integer
  regex = pcre_compile(aPattern, 0, @errcode, @erroffset, 0)
  if regex = 0 then
    return 0
  end if
  return pcre_exec(regex, 0, aBuffer, len(aBuffer), 0, 0, @ovector, 1) = 0
end function
#endif

#ifdef USE_TRE
#include "regex.bi"
function IsMatch(byval aPattern as string, byval aSubject as string) as integer
	dim e as regex_t
	dim m as regmatch_t
	dim p as zstring ptr
	regcomp(@e, aPattern, 0)
  p = strptr(aSubject)
	function = regexec(@e, p, 1, @m, 0) = 0
	regfree(@e)
end function
#endif

#ifdef USE_CREGEX
#include "cregex.bi"
function IsMatch(byval aPattern as string, byval aSubject as string) as integer
  var reg = new CRegex(aPattern)
  if reg = NULL then
    return 0
  end if
  function = reg->search(aSubject)
  delete reg
end function
#endif
