
#include "..\board.bas"
#include "testutils.bas"

dim brd as tBoard

dim i as integer

brd.Initialize()

Open ExeName() & ".txt" for output as #1

function SquareToByte(byval s as string) as byte
  function = 10 * (s[0] - Asc("a") + 1) + s[1] - Asc("0")
end function

function ByteToSquare(byval b as byte) as string
  return Chr(b \ 10 + Asc("a") - 1, b mod 10 + Asc("0"))
end function

const s = "e2e3d7d5f1e2e7e5g1f3e5e4"

for i = 1 to Len(s) \ 4
  brd.GenerateAllMoves()
  Print #1, Mid(s, 4 * i - 3, 4)
  brd.MovePiece(SquareToByte(Mid(s, 4 * i - 3, 2)), SquareToByte(Mid(s, 4 * i - 1, 2)))
  Print #1, brd.Text()
next i

brd.GenerateAllMoves()

for i = 1 to brd.list.count
  Print #1, ByteToSquare(brd.list.array(i).fromSquare) & ByteToSquare(brd.list.array(i).toSquare)
next i

Close #1
